#region Copyright Syncfusion Inc. 2001-2018.
// Copyright Syncfusion Inc. 2001-2018. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.WinForms.DataGrid;
using System.IO;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf;
using Syncfusion.WinForms.DataGrid.Enums;
using Syncfusion.WinForms.DataGridConverter;
using Syncfusion.WinForms.DataGridConverter.Events;
using Syncfusion.Windows.Forms.PdfViewer;
using Syncfusion.WinForms.Core.Utils;
using Syncfusion.XlsIO;

namespace PdfExporting
{
    public partial class Form1 : Form
    {
        BusyIndicator busyIndicator = new BusyIndicator();
        public Form1()
        {
            InitializeComponent();
            ProductInfoRepository pro = new ProductInfoRepository();
            sfDataGrid1.DataSource = pro.ProductInfo;
            
            GridSettings();
            this.sfButton2.Click += new System.EventHandler(this.ExportToPDFButton_Click);
            progressBar.Maximum = sfDataGrid1.RowCount;
            
        }

        /// <summary>
        /// Grid Settings for better Look and Feel.
        /// </summary>    
        private void GridSettings()
        {
            this.sfDataGrid1.Columns.Add(new GridNumericColumn() { MappingName = "SupplierID", HeaderText = "Supplier ID", NumberFormatInfo = new System.Globalization.NumberFormatInfo() { NumberDecimalDigits = 0, NumberGroupSeparator = "" } });
            this.sfDataGrid1.Columns.Add(new GridNumericColumn() { MappingName = "ProductID", HeaderText = "Product ID", NumberFormatInfo = new System.Globalization.NumberFormatInfo() { NumberDecimalDigits = 0, NumberGroupSeparator = "" } });
            this.sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "ProductName", HeaderText = "Product Name" });
            this.sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "QuantityPerUnit", HeaderText = "Quantity Per Unit" });
            this.sfDataGrid1.Columns.Add(new GridNumericColumn() { MappingName = "UnitPrice", HeaderText = "Unit Price ", FormatMode = Syncfusion.WinForms.Input.Enums.FormatMode.Currency });
            this.sfDataGrid1.Columns.Add(new GridNumericColumn() { MappingName = "UnitsInStock", HeaderText = "Units In Stock", NumberFormatInfo = new System.Globalization.NumberFormatInfo() { NumberDecimalDigits = 0, } });
        }

        void ExportToPDFButton_Click(object sender, System.EventArgs e)
        {
            busyIndicator.Show(this.sfDataGrid1.TableControl);

            var options = new ExcelExportingOptions();
            options.CellExporting += Options_CellExporting;
            var excelEngine = sfDataGrid1.ExportToExcel(sfDataGrid1.View, options);
            var workBook = excelEngine.Excel.Workbooks[0];
            workBook.SaveAs("Book.xlsx");
            System.Diagnostics.Process.Start("Book.xlsx");

            busyIndicator.Hide();
        }

        private void Options_CellExporting(object sender, DataGridCellExcelExportingEventArgs e)
        {
            this.progressBar.Value = (sender as ExcelExportingOptions).RowIndex;
        }
    }
}
